# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetRdpCaPubkeyResult',
    'AwaitableGetRdpCaPubkeyResult',
    'get_rdp_ca_pubkey',
    'get_rdp_ca_pubkey_output',
]

@pulumi.output_type
class GetRdpCaPubkeyResult:
    """
    A collection of values returned by getRdpCaPubkey.
    """
    def __init__(__self__, id=None, public_key=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if public_key and not isinstance(public_key, str):
            raise TypeError("Expected argument 'public_key' to be a str")
        pulumi.set(__self__, "public_key", public_key)

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        a generated id representing this request.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="publicKey")
    def public_key(self) -> Optional[builtins.str]:
        """
        the RDP Certificate Authority public key.
        """
        return pulumi.get(self, "public_key")


class AwaitableGetRdpCaPubkeyResult(GetRdpCaPubkeyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRdpCaPubkeyResult(
            id=self.id,
            public_key=self.public_key)


def get_rdp_ca_pubkey(id: Optional[builtins.str] = None,
                      public_key: Optional[builtins.str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRdpCaPubkeyResult:
    """
    The RDP CA Pubkey is a public key used for setting up a trusted CA on Active Directiory Domain Controllers.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdm as sdm

    rdp_pubkey_query = sdm.get_rdp_ca_pubkey()
    pulumi.export("rdpca", rdp_pubkey_query.public_key)
    ```


    :param builtins.str id: a generated id representing this request.
    :param builtins.str public_key: the RDP Certificate Authority public key.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['publicKey'] = public_key
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdm:index/getRdpCaPubkey:getRdpCaPubkey', __args__, opts=opts, typ=GetRdpCaPubkeyResult).value

    return AwaitableGetRdpCaPubkeyResult(
        id=pulumi.get(__ret__, 'id'),
        public_key=pulumi.get(__ret__, 'public_key'))
def get_rdp_ca_pubkey_output(id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                             public_key: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                             opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetRdpCaPubkeyResult]:
    """
    The RDP CA Pubkey is a public key used for setting up a trusted CA on Active Directiory Domain Controllers.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdm as sdm

    rdp_pubkey_query = sdm.get_rdp_ca_pubkey()
    pulumi.export("rdpca", rdp_pubkey_query.public_key)
    ```


    :param builtins.str id: a generated id representing this request.
    :param builtins.str public_key: the RDP Certificate Authority public key.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['publicKey'] = public_key
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sdm:index/getRdpCaPubkey:getRdpCaPubkey', __args__, opts=opts, typ=GetRdpCaPubkeyResult)
    return __ret__.apply(lambda __response__: GetRdpCaPubkeyResult(
        id=pulumi.get(__response__, 'id'),
        public_key=pulumi.get(__response__, 'public_key')))
