# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['ManagedSecretValueArgs', 'ManagedSecretValue']

@pulumi.input_type
class ManagedSecretValueArgs:
    def __init__(__self__, *,
                 public_key: pulumi.Input[builtins.str],
                 value: pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]):
        """
        The set of arguments for constructing a ManagedSecretValue resource.
        :param pulumi.Input[builtins.str] public_key: secret engine's public key used for encryption in PEM format
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] value: value object
        """
        pulumi.set(__self__, "public_key", public_key)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="publicKey")
    def public_key(self) -> pulumi.Input[builtins.str]:
        """
        secret engine's public key used for encryption in PEM format
        """
        return pulumi.get(self, "public_key")

    @public_key.setter
    def public_key(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "public_key", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]:
        """
        value object
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class _ManagedSecretValueState:
    def __init__(__self__, *,
                 encrypted: Optional[pulumi.Input[builtins.str]] = None,
                 public_key: Optional[pulumi.Input[builtins.str]] = None,
                 value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None):
        """
        Input properties used for looking up and filtering ManagedSecretValue resources.
        :param pulumi.Input[builtins.str] encrypted: encrypted value
        :param pulumi.Input[builtins.str] public_key: secret engine's public key used for encryption in PEM format
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] value: value object
        """
        if encrypted is not None:
            pulumi.set(__self__, "encrypted", encrypted)
        if public_key is not None:
            pulumi.set(__self__, "public_key", public_key)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def encrypted(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        encrypted value
        """
        return pulumi.get(self, "encrypted")

    @encrypted.setter
    def encrypted(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "encrypted", value)

    @property
    @pulumi.getter(name="publicKey")
    def public_key(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        secret engine's public key used for encryption in PEM format
        """
        return pulumi.get(self, "public_key")

    @public_key.setter
    def public_key(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "public_key", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        value object
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "value", value)


@pulumi.type_token("sdm:index/managedSecretValue:ManagedSecretValue")
class ManagedSecretValue(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 public_key: Optional[pulumi.Input[builtins.str]] = None,
                 value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        """
        Create a ManagedSecretValue resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] public_key: secret engine's public key used for encryption in PEM format
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] value: value object
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ManagedSecretValueArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a ManagedSecretValue resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param ManagedSecretValueArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ManagedSecretValueArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 public_key: Optional[pulumi.Input[builtins.str]] = None,
                 value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ManagedSecretValueArgs.__new__(ManagedSecretValueArgs)

            if public_key is None and not opts.urn:
                raise TypeError("Missing required property 'public_key'")
            __props__.__dict__["public_key"] = public_key
            if value is None and not opts.urn:
                raise TypeError("Missing required property 'value'")
            __props__.__dict__["value"] = value
            __props__.__dict__["encrypted"] = None
        super(ManagedSecretValue, __self__).__init__(
            'sdm:index/managedSecretValue:ManagedSecretValue',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            encrypted: Optional[pulumi.Input[builtins.str]] = None,
            public_key: Optional[pulumi.Input[builtins.str]] = None,
            value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None) -> 'ManagedSecretValue':
        """
        Get an existing ManagedSecretValue resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] encrypted: encrypted value
        :param pulumi.Input[builtins.str] public_key: secret engine's public key used for encryption in PEM format
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] value: value object
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ManagedSecretValueState.__new__(_ManagedSecretValueState)

        __props__.__dict__["encrypted"] = encrypted
        __props__.__dict__["public_key"] = public_key
        __props__.__dict__["value"] = value
        return ManagedSecretValue(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def encrypted(self) -> pulumi.Output[builtins.str]:
        """
        encrypted value
        """
        return pulumi.get(self, "encrypted")

    @property
    @pulumi.getter(name="publicKey")
    def public_key(self) -> pulumi.Output[builtins.str]:
        """
        secret engine's public key used for encryption in PEM format
        """
        return pulumi.get(self, "public_key")

    @property
    @pulumi.getter
    def value(self) -> pulumi.Output[Mapping[str, builtins.str]]:
        """
        value object
        """
        return pulumi.get(self, "value")

